'use strict';

var express         = require('express');
var path            = require('path');
// var favicon         = require('serve-favicon');
var logger          = require('morgan');
var cookieParser    = require('cookie-parser');
var bodyParser      = require('body-parser');

// load JARVIS configuraton json
var Config = require('./config/<%= sluggedAppname %>');



var app = express();

// app vars setup
app.set('title', Config.get('name'));
app.set('version', Config.get('version'));
// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');



// uncomment after placing your favicon in /public
//app.use(favicon(__dirname + '/public/favicon.ico'));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

// routes files
app.use('/', require('./routes/index'));
app.use('/api', require('./routes/api'));
app.use('/<%= sluggedAppname %>', require('./routes/<%= sluggedAppname %>'));


// catch 404 and forward to error handler
app.use(function(req, res, next) {
    var err = new Error('Not Found');
    err.status = 404;
    next(err);
});


// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
    app.use(function(err, req, res) {
        var pageData = {
            message: err.message,
            error: err
        };

        if (err.code === 'ECONNREFUSED') {
            pageData.message = 'There\'s a connection refused error!  Your app requires a working database connection.';
        }
        
        res.status(err.status || 500);
        res.render('error', pageData);
    });
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res) {
    res.status(err.status || 500);
    res.render('error', {
        message: err.message,
        error: {}
    });
});


module.exports = app;
